modules

# Class: ddns

Source Location: /lib/modules/ddns.inc

### Class Overview

    baseModule
       |
       --ddns

Manages DDNS entries.

#### Author(s):

- Roland Gruber

### Variables

- $ddns

### Methods

- build_uploadAccounts
- display_html_attributes
- get_metaData
- get_pdfEntries
- init
- load_attributes
- load_Messages
- module_complete
- process_attributes
- process_attributes_account
- process_attributes_mainSettings

### Inherited Variables

#### Class: baseModule

baseModule::$attributes
baseModule::$autoAddObjectClasses
baseModule::$messages
baseModule::$meta
baseModule::$moduleSettings
baseModule::$orig
baseModule::$selfServiceSettings

### Inherited Methods

#### Class: baseModule

baseModule::__construct()
  Creates a new base module class
baseModule::build_uploadAccounts()
  In this function the LDAP accounts are built.
baseModule::can_manage()
  Returns true if this module can manage accounts of the current type, otherwise false.
baseModule::checkSelfServiceOptions()
  Checks if all input values are correct and returns the LDAP attributes which should be changed.
baseModule::checkSelfServiceSettings()
  Checks if the self service settings are valid.
baseModule::check_configOptions()
  Checks input values of module settings.
baseModule::check_profileOptions()
  Checks input values of account profiles.
baseModule::delete_attributes()
  This function returns an array with the same syntax as save_attributes().
baseModule::display_html_attributes()
  This function creates meta HTML code to display the module page.
baseModule::display_html_delete()
  This function creates meta HTML code which will be displayed when an account should be deleted.
baseModule::doUploadPostActions()
  This function is responsible to do additional tasks after the account has been created in LDAP (e.g. modifying group memberships, adding Quota etc..).
baseModule::getAccountContainer()
  Returns the accountContainer object.
baseModule::getAttributes()
  Returns the LDAP attributes which are managed in this module.
baseModule::getButtonStatus()
  Controls if the module button the account page is visible and activated.
baseModule::getIcon()
  Returns the path to the module icon.
baseModule::getLDAPAliases()
  Returns a list of aliases for LDAP attributes.
baseModule::getManagedAttributes()
  Returns a list of LDAP attributes which are managed by this module.
baseModule::getManagedObjectClasses()
  Returns a list of managed object classes for this module.
baseModule::getOriginalAttributes()
  Returns the LDAP attributes which are managed in this module (with unchanged values).
baseModule::getRequiredExtensions()
  This function returns a list of PHP extensions (e.g. hash) which are needed by this module.
baseModule::getSelfServiceFields()
  Returns a list of possible input fields and their descriptions.
baseModule::getSelfServiceOptions()
  Returns the meta HTML code for each input field.
baseModule::getSelfServiceSearchAttributes()
  This function returns a list of possible LDAP attributes (e.g. uid, cn, ...) which can be used to search for LDAP objects.
baseModule::getSelfServiceSettings()
  Returns a list of self service configuration settings.
baseModule::get_alias()
  Returns an alias name for the module.
baseModule::get_configOptions()
  Returns a list of configuration options.
baseModule::get_dependencies()
  This function returns a list with all depending and conflicting modules.
baseModule::get_help()
  This function returns the help entry array for a specific help id.
baseModule::get_ldap_filter()
  Returns an LDAP filter for the account lists
baseModule::get_metaData()
  This function provides meta data which is interpreted by baseModule.
baseModule::get_pdfEntries()
  Returns the PDF entries for this module.
baseModule::get_pdfFields()
  Returns a hashtable with all entries that may be printed out in the PDF.
baseModule::get_profileOptions()
  This function defines what attributes will be used in the account profiles and their appearance in the profile editor.
baseModule::get_RDNAttributes()
  Returns a hash array containing a list of possible LDAP attributes that can be used to form the RDN (Relative Distinguished Name).
baseModule::get_scope()
  Returns the account type of this module (user, group, host)
baseModule::get_uploadColumns()
  Returns an array containing all input columns for the file upload.
baseModule::get_uploadPreDepends()
  Returns a list of module names which must be processed in building the account befor this module.
baseModule::init()
  Initializes the module after it became part of an accountContainer
baseModule::is_base_module()
  Returns true if your module is a base module and otherwise false.
baseModule::load_attributes()
  This function loads the LDAP attributes when an account should be loaded.
baseModule::load_Messages()
  This function fills the $messages variable with output messages from this module.
baseModule::load_profile()
  This function loads the values from an account profile to the module's internal data structures.
baseModule::module_complete()
  This function is used to check if all settings for this module have been made.
baseModule::module_ready()
  This function is used to check if this module page can be displayed.
baseModule::postDeleteActions()
  Allows the module to run commands after the LDAP entry is deleted.
baseModule::postModifyActions()
  Allows the module to run commands after the LDAP entry is changed or created.
baseModule::preDeleteActions()
  Allows the module to run commands before the LDAP entry is deleted.
baseModule::preModifyActions()
  Allows the module to run commands before the LDAP entry is changed or created.
baseModule::process_attributes()
  This function processes user input.
baseModule::save_attributes()
  Returns a list of modifications which have to be made to the LDAP account.

### Class Details

[line 40]
Manages DDNS entries.

#### Tags:

author: | Roland Gruber

[ Top ]

### Class Variables

#### $ddns = array()

[line 43]

#### Tags:

access: | public

Type: | mixed

[ Top ]

### Class Methods

### method build_uploadAccounts [line 620]

`array build_uploadAccounts( array $rawAccounts, array $ids, &$partialAccounts, array $partialAccounts)`

In this function the LDAP account is built up.

#### Tags:

return: | list of error messages if any

Overrides baseModule::build_uploadAccounts() (In this function the LDAP accounts are built.)

#### Parameters:

array | $rawAccounts | list of hash arrays (name => value) from user input
array | $partialAccounts | list of hash arrays (name => value) which are later added to LDAP
array | $ids | list of IDs for column position (e.g. "posixAccount_uid" => 5)
| &$partialAccounts |

[ Top ]

### method display_html_attributes [line 322]

`array display_html_attributes( )`

Returns the HTML meta data for the main account page.

#### Tags:

return: | HTML meta data
access: | public

Overrides baseModule::display_html_attributes() (This function creates meta HTML code to display the module page.)
[ Top ]

### method get_metaData [line 59]

`void get_metaData( )`

#### Tags:

access: | public

Overrides baseModule::get_metaData() (This function provides meta data which is interpreted by baseModule.)
[ Top ]

### method get_pdfEntries [line 395]

`array get_pdfEntries( )`

Returns the PDF entries for this module.

#### Tags:

return: | list of possible PDF entries
access: | public

Overrides baseModule::get_pdfEntries() (Returns the PDF entries for this module.)
[ Top ]

### method init [line 53]

`void init( string $base)`

Initializes the module after it became part of an accountContainer

Calling this method requires the existence of an enclosing accountContainer.

#### Tags:

access: | public

Overrides baseModule::init() (Initializes the module after it became part of an accountContainer)

#### Parameters:

string | $base | the name of the accountContainer object ($_SESSION[$base])

[ Top ]

### method load_attributes [line 608]

`void load_attributes( array $attributes)`

This function loads the LDAP attributes when an account should be loaded.

Calling this method requires the existence of an enclosing accountContainer.
By default this method loads the object classes and accounts which are specified in getManagedObjectClasses() and getManagedAttributes().

#### Tags:

access: | public

Overrides baseModule::load_attributes() (This function loads the LDAP attributes when an account should be loaded.)

#### Parameters:

array | $attributes | array like the array returned by get_ldap_attributes(dn of account) but without count indices

[ Top ]

### method load_Messages [line 141]

`void load_Messages( )`

This function fills the message array.

#### Tags:

access: | public

Overrides baseModule::load_Messages() (This function fills the $messages variable with output messages from this module.)
[ Top ]

### method module_complete [line 155]

`boolean module_complete( )`

This functions returns true if all needed settings are done.

#### Tags:

return: | true if LDAP operation can be done
access: | public

Overrides baseModule::module_complete() (This function is used to check if all settings for this module have been made.)
[ Top ]

### method process_attributes [line 209]

`array process_attributes( )`

Processes user input of the primary module page.

It checks if all input values are correct and updates the associated LDAP attributes.

#### Tags:

return: | list of info/error messages
access: | public

Overrides baseModule::process_attributes() (This function processes user input.)
[ Top ]

### method process_attributes_account [line 273]

`void process_attributes_account( )`

Process for account

#### Tags:

access: | public

[ Top ]

### method process_attributes_mainSettings [line 232]

`void process_attributes_mainSettings( )`

Process for mainsettings

#### Tags:

access: | public

[ Top ]

Documentation generated on Wed, 05 Aug 2009 19:52:55 +0200 by phpDocumentor 1.4.1